/*****************************************************/
/* shell.h                                           */
/* -- Interface to Shell VxD.                        */
/*****************************************************/

/* PIF flags. */
#define fExcl      0x00000001 /* Exclusive mode. */
#define fpifBack   0x00000002 /* Runs in background. */
#define fpifWindow 0x00000004 /* Runs in a window. */
#define fpifAltTab 0x00000020 /* Alt-Tab reserved. */
#define fpifAltEsc 0x00000040 /* Alt-Esc reserved. */
#define fpifAltSp  0x00000080 /* Alt-Sp reserved. */
#define fpifAltEnt 0x00000100 /* Alt-Ent reserved. */
#define fpifAltPsc 0x00000200 /* Alt-PrtSc reserved. */
#define fpifPrtSc  0x00000400 /* PrtSc reserved. */
#define fpifCtlEsc 0x00000800 /* Ctl-Esc reserved. */
#define fpifIdle   0x00001000 /* Detect idle. */
#define fpifNoHMA  0x00002000 /* Don't use High Mem. */
#define fpifEmsLok 0x00008000 /* EMS memory locked. */
#define fpifXmsLok 0x00010000 /* XMS memory locked. */
#define fpifFPaste 0x00020000 /* Allow Fast Paste. */
#define fpifAppLok 0x00040000 /* Lock app. memory. */
#define fpifCloseE 0x40000000 /* Close on exit. */

/* Display flags. */
#define fdisEmText 0x00000001 /* Emulate text mode. */
#define fdisNoText 0x00000002 /* No monitor text mode. */
#define fdisNoLow  0x00000004 /* No monitor low gfx. */
#define fdisNoHigh 0x00000008 /* No monitor high gfx. */
#define fdisRetain 0x00000080 /* Retain video memory. */

typedef struct
    {
    DWORD ib;  /* 32 bit Offset. */
    WORD  sel; /* Selector. */
    } WFP;     /* Wide (48 bits) far pointer. */

typedef struct
    {
    DWORD   grfpif;     /* PIF flags. */
    DWORD   grfdis;     /* Display flags. */
    WFP     wfpExe;     /* Path of .exe to run. */
    WFP     wfpArgs;    /* Argument list. */
    WFP     wfpWork;    /* Working drive/dir. */
    WORD    cpagWant;   /* Desired V86 pages for VM. */
    WORD    cpagMin;    /* Minimum V86 pages for VM. */
    WORD    wForePriority; /* Foreground priority. */
    WORD    wBackPriority; /* Background priority. */
    WORD    ckbMaxEMS;  /* Maximum EMS KB. */
    WORD    ckbMinEMS;  /* Minimum EMS KB. */
    WORD    ckbMaxXMS;  /* Maximum XMS KB. */
    WORD    ckbMinXMS;  /* Minimum XMS KB. */
    WORD    wUnknown1;
    WORD    wUnknown2;
    char    szTitle[128];
    } SEB;              /* Shell Execute Block. */
